unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBClient, MsDataAdapter, StdCtrls, Grids, DBGrids, ADODB,
  ExtCtrls, DBCtrls, Provider, DBTables, WideStrings, SqlExpr;

type
  TForm2 = class(TForm)
    MsDataAdapter1: TMsDataAdapter;
    ADOConnection1: TADOConnection;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    btnOpen: TButton;
    DBNavigator1: TDBNavigator;
    btnApply: TButton;
    btnCancel: TButton;
    btnClose: TButton;
    SQLConnection1: TSQLConnection;
    Label1: TLabel;
    cbDatabaseType: TComboBox;
    procedure btnOpenClick(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.btnCancelClick(Sender: TObject);
begin
  MsDataAdapter1.CancelUpdates;
end;

procedure TForm2.btnCloseClick(Sender: TObject);
begin
  MsDataAdapter1.Close;
end;

procedure TForm2.btnOpenClick(Sender: TObject);
begin
  MsDataAdapter1.Close;
  case cbDatabaseType.ItemIndex of
    0: MsDataAdapter1.Connection := ADOConnection1;
    1: MsDataAdapter1.Connection := SQLConnection1;
    2:
    begin
      MessageDlg('This demo does not implemete IBX, though TDataAdapter supports it.'#13#10'You can modify the demo for using Interbase/Firebird.', mtInformation, [mbOk], 0);
      cbDatabaseType.ItemIndex := 0;
      MsDataAdapter1.Connection := ADOConnection1;
    end;
    3:
    begin
      MessageDlg('This demo does not implemete BDE, though TDataAdapter supports it.'#13#10'You can modify the demo for using BDE.', mtInformation, [mbOk], 0);
      cbDatabaseType.ItemIndex := 0;
      MsDataAdapter1.Connection := ADOConnection1;
    end;
  end;
  if MsDataAdapter1.Connection = nil then
    Exit;
  MsDataAdapter1.Connection.Connected := True;
  MsDataAdapter1.Open;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  cbDatabaseType.ItemIndex := 0;
end;

procedure TForm2.btnApplyClick(Sender: TObject);
begin
  MsDataAdapter1.ApplyUpdates;
end;

end.
